% Imagen LAI del producto GEOV1/VGT a 0.5? de resolucin espacial, ventana lat=[40:70] / lon=[20:80]
% 
% Formato: little-endian, BIL, uint8(60,120,504)
% nrow=60 (lineas correspondientes a lat 40:0.5:70)
% ncol=120 (columnas correspondientes a lon 20:0.5:80)
% nband=504 (3 * 12 meses *14 aos = 504 fechas diferentes cada 10 dias desde 5/01/1999 - 15/01/1999 - 25/01/1999 - ... 25/12/2012)
% 
% Fill_value=255: valores no validos (mar/ no data)
% 
% Para transformar los valores de la imagen en valores de LAI, debe utilizarse el siguiente factor de conversion:
% Scale factor=30 (LAI=imagen/30)
% 
% Valor_Maximo_LAI=7 (El rango fsico de LAI es 0-7. Despues de hacer la
% transformacin, enmascarar valores de LAI mayores a 7 si los hubiera):NaN (not a number)

clc; close all;clear all;


% addpath ('/Users/geodesman/Documents/Master Teledeteccion/Material/ATD/Info_Trabajos/TrabajoBiosfera/Datos_Matlab/prog/');
% pathim='/Users/geodesman/Documents/Master Teledeteccion/Material/ATD/Info_Trabajos/TrabajoBiosfera/Datos_Matlab/';
% pathres='/Users/geodesman/Documents/Master Teledeteccion/Material/ATD/Info_Trabajos/TrabajoBiosfera/Datos_Matlab/Resultados/'; 

nrow=60;
ncol=120;
nband=504;

% input file 
% fimGEOV1=[pathim,'LAI_GEOV1_VGT_1999_2012_lat40_70_lon50_80'];

%convertimemos nuestra imagen en valores de reflecividad; ND a Reflectividad
%              
%factor de conversion ND a valores de LAI
facrefGEOV1=1/30;


% Leeemos la imagen y pasamos a valores de REFLECTIVIDAD
% X = multibandread(FILENAME,SIZE,PRECISION,OFFSET,INTERLEAVE,BYTEORDER)
% im=multibandread(fimGEOV1, [nrow ncol nband], 'uint8', 0, 'bil','ieee-le');
im=multibandread('LAI_GEOV1_VGT_1999_2012_lat40_70_lon50_80', [nrow ncol nband], 'uint8', 0, 'bil','ieee-le');

NoVal=numel(im(im==255)); % 1058092 valores no validos (mar/ no data) 255*facrefGEOV1 
% nos dara 8.5, que es un valor >7 y se sale del Rango de LAI (0-7)

im=im*facrefGEOV1;

% Rango ha de ser 0-7. Mayores de 7 se enmascaran (NoVal)
min=min(min(min(im))); % No tengo valores negativos, min=0
max=max(max(max(im))); % El valor maximo=8.5

mayores7=numel(im(im>7)); % 1058092 valores por encima del rango de LAI (NoVal)
menores0=numel(im(im<0)); % Al no haber valores por debajo de 0 todos los valores 0 o =<7 sern mis datosa a estudiar (2570708)
menores7=numel(im(im<=7)); % 2570708. He de enmascarar el resto (1058092)

% break
% nrow=60;ncol=120;nband=504;
LAIrange=7;

for H = 1: nrow
    for F = 1: ncol
        for G = 1: nband
            if im(H,F,G) > LAIrange
                im(H,F,G) = NaN;
            end
        end
    end
end

% n=find(im(im==NaN));
% n=numel(im(im=NaN))
% k=numel(im(im=='NaN'));
% break


% fimLAI=[pathres,'LAI_proces'];
OUT=enviwrite1(im,'LAI_proces');

% OUT=multibandwrite(im,fimLAI,'bil');
% multibandwrite(data,filename,interleave,start,totalsize)
% multibandwrite(...,param,value...)
% %Designamos los nombres de los archivos de salida
% fileout1=[pathres,'NVDI TM'];
% fileout2=[pathres,'SAVI TM'];
% fileout3=[pathres,'RVI TM'];
% 
% %La funcin 'enviwrite1.m' proporcioanda creara el archivo *.hdr de cada
% %indice calculado
% i1=enviwrite1(NVDI,fileout1);
% i2=enviwrite1(SAVI,fileout2);
% i3=enviwrite1(RVI,fileout3);